// algorithm1.cpp: Ein erstes Beispiel mit den Algorithmen.
// ---------------------------------------------------------------
#include <iostream>
#include <list>            // Definition des list-Templates 
#include <algorithm>       // Definition der Algorithmen-Templates
#include <ctime>           // Funktionen time(), ...
#include <cstdlib>         // Funktionen srand(), rand(), ...
using namespace std;

typedef list<int> INTLIST;                 // int-Liste

void print( int elm) {  cout.width(5);  cout << elm; }

int main()
{
    INTLIST intList;                       // Leere Liste anlegen

    srand( (unsigned int)time(NULL));
    for( int i = 0; i < 10; ++i)           // 10 Zufallszahlen mit Werten
      intList.push_back(rand()%100);       // zwischen 0 und 99 einfgen.

    // Mit dem Algorithmus for_each() die Liste durchlaufen: 
    for_each( intList.begin(), intList.end(), print);  // Fr jedes Element die Funktion
    cout << endl;                                      // print() aufrufen.

    // Mit dem Algorithmus min_element() das Minimum suchen:
    INTLIST::iterator pos;                 // Ein Iterator.
    pos = min_element( intList.begin(), intList.end() );
    cout << "Das Minimum: " << *pos << endl;

    // Und mit max_element() das Maximum suchen:
    pos = max_element( intList.begin(), intList.end());
    cout << "Das Maximum: " << *pos << endl;

    return 0;
}

/* Beispiel-Ausgabe:
    5   98    5   79   35   18   83   15   75   24
Das Minimum: 5
Das Maximum: 98
*/
