// transform.cpp: Elemente kopieren und transformieren.
// ---------------------------------------------------------------
#include <iostream>
#include <vector>           // Definition des vector-Templates        
#include <algorithm>        // Definition der Algorithmen-Templates
#include <functional>       // Vordefinierte Funktionsobjekte
#include <iterator>
#include <cmath>            // Fuer sqrt()
using namespace std;

int main()
{
    vector<double> dblVec1;                 // Leeren Vektor anlegen

    // Zahlen von der Standard-Eingabe in den Vektor einlesen:
    cout << "Einige positive Zahlen eingeben "
            "(Eingabe mit einem Buchstabe beenden):" << endl; 
    copy( istream_iterator<double>(cin),     // istream-Iterator
          istream_iterator<double>(),        // EOF-Iterator  
          back_inserter(dblVec1));           // Back-Inserter

    cout << "\nIhre Eingabe: " << endl;
    copy( dblVec1.begin(), dblVec1.end(),    // Vector nach cout
          ostream_iterator<double>(cout, "  "));    // kopieren.
    cout << endl;  
    // Zweiter Vektor mit der Lnge von dblVec1 anlegen:  
    vector<double> dblVec2( dblVec1.size()); 

    // Wurzeln berechen:
    transform( dblVec1.begin(), dblVec1.end(),   // Quellbereich 
               dblVec2.begin(),                  // Zielbereich 
               (double(*)(double))sqrt );        // Funktion

    // Ergebnis anzeigen:
    cout << "\nDie Wurzeln der Zahlen: " << endl;
    copy( dblVec2.begin(), dblVec2.end(), 
          ostream_iterator<double>(cout, "  "));
    cout << endl;  

    // Zeiten Vector elementweise zum ersten hinzuaddieren:
    transform( dblVec1.begin(), dblVec1.end(), // 1. Quellbereich 
               dblVec2.begin(),                // 2. Quellbereic
               dblVec1.begin(),                // Zielbereich
               plus<double>() );               // Funktionsobjekt

    // Ergebnis anzeigen:
    cout << "\nSumme der zwei Vektoren: " << endl;
    copy( dblVec1.begin(), dblVec1.end(), 
          ostream_iterator<double>(cout, "  "));
    cout << endl;  
    return 0;
}

/* Beispiel-Ausgabe:

Einige positive Zahlen eingeben (Eingabe mit einem Buchstabe beenden):
4 9  2.25 25q

Ihre Eingabe:
4  9  2.25  25

Die Wurzeln der Zahlen:
2  3  1.5  5

Summe der zwei Vektoren:
6  12  3.75  30

*/

