//-------------------------------------------------------------
// Ellipse.cpp
// Dieses Programm zeichnet eine Ellipse.
// Fr die Punkte (x,y) einer Ellipse mit dem Mittelpunkt (0,0),
// der Hauptachse A und der Nebenachse B gilt: 
//    x = A*cos(t), y = B*sint(t)  fr  0 <= t <= 2*PI .
// ------------------------------------------------------------
//  Statt der ANSI-Bildschirmsteuerzeichen werden hier
//  die Funktionen der Windows-API verwendet.
// ------------------------------------------------------------

#include <iostream>
#include <cmath>        // Prototypen von sin() und cos()
using namespace std;

#include "..\..\console\console.h"       // Win32 Konsolenfunktionen

#define  CLS          cls()              // Bildschirm loeschen
#define  LOCATE(z,s)  setCursor(z-1,s-1) // Cursor in Zeile z, 
                                         // Spalte s positionieren.
#define  DOT(x,y)    LOCATE(y,x); (cout << '*')

#define  PI 3.1416
#define  Mx 40               // Der Punkt (Mx, My) ist der
#define  My 12               // Mittelpunkt der Ellipse.
#define  A  25               // Lnge der Hauptachse, 
#define  B  10               // Lnge der Nebenachse. 

int main()
{
    int x,y;                 // Bildschirmkoordinaten.  

    CLS;
                   // 0 <= t <= PI/2 ist ein 1/4-Kreis:
    for( double t = 0.0 ; t <= PI/2 ; t += 0.03)
    {
       x = (int) (A * cos(t) + 0.5);
       y = (int) (B * sin(t) + 0.5);

       DOT( x+Mx, y+My);
       DOT( x+Mx,-y+My);
       DOT(-x+Mx, y+My);
       DOT(-x+Mx,-y+My);
    }
    LOCATE(24,1);

    return 0;
}
