// fibo.cpp
// Dieses Programm berechnet die ersten 20 Fibonacci-
// Zahlen und die zugehrigen Fibonacci-Quotienten.
// -----------------------------------------------------

#include <iostream>
#include <iomanip>
#include <cmath>        // Fr den Prototyp von sqrt()
#include <string>
using namespace std;

#define ANZAHL 20

long fib[ANZAHL + 1] = { 0, 1 };

string header =
"\n Index   Fibonacci-Zahl   Fibonacci-Quotient    Abweichung"
"\n                                                vom Grenzwert"
"\n-------------------------------------------------------------";

int main()
{
  int i;
  double q, lim;

  for( i=1; i < ANZAHL; ++i )        // Berechnung der
    fib[i+1] = fib[i] + fib[i-1];    // Fibonacci-Zahlen

  lim = ( 1.0 + sqrt(5.0)) / 2.0;   // Grenzwert

  // berschrift und die ersten zwei Fibonacci-Zahlen:
  cout << header << endl; 
  cout << setw(5) << 0 << setw(15) << fib[0] << endl;
  cout << setw(5) << 1 << setw(15) << fib[1] << endl;

  // Der Rest der Tabelle:
  for( i=2; i <= ANZAHL; i++ )
  {                                 // Quotient:
    q = (double)fib[i] / (double)fib[i-1];
 
    cout << setw(5)  << i << setw(15) << fib[i] 
         << setw(20) << fixed << setprecision(10) << q
         << setw(20) << scientific << setprecision(3)
         << lim - q  << endl;
  } 
  return 0;
}

/*
// fibo_0.cpp
// Berechnung die ersten 20 Fibonacci-Zahlen
// -----------------------------------------------------

#include <iostream>
#include <iomanip>
using namespace std;

#define ANZAHL 20

long fib[ANZAHL + 1] = { 0, 1 };

int main()
{
   int i;

   for( i=1; i < ANZAHL; ++i )         // Berechnung der
      fib[i+1] = fib[i] + fib[i-1];    // Fibonacci-Zahlen

   cout << "\n Index        Fibonacci-Zahl\n"
        << "-------------------------------" << endl; 

   cout << setw(5) << 0 << setw(20) << fib[0] << endl;
   cout << setw(5) << 1 << setw(20) << fib[1] << endl;

   for( i=2; i <= ANZAHL; i++ )
      cout << setw(5) << i << setw(20) << fib[i] << endl;

   return 0;
}
*/