// listDir.cpp : Zeigt das aktuelle Verzeichnis oder
//               das angegebene Verzeichnis an.
// -------------------------------------------------------

#include <iostream>
#include <filesystem>
using namespace std;
namespace fs = experimental::filesystem;         // Abkrzung.
// Visual C++ 2017: filesystem noch im Namespace experimental.

bool listDirectory( const fs::path& p);

int main(int argc, char* argv[])
{
   if( argc > 2)
   {  cout << "Verwendung: listDir [Verzeichnis]" << endl;
      return 1;
   }

   try
   {
     fs::path p( (argc < 2) ? "." : argv[1]);

     if( !fs::exists(p))               // Existiert der Pfad?
       cout << p << " existiert nicht." << endl;
     else
       if( !listDirectory(p) )
         cout << p << " existiert, ist aber kein Verzeichnis."
              << endl;
   }
   catch( const fs::filesystem_error& ex)
   {  cout << ex.what() << endl;  }

   return 0;
}

bool listDirectory(const fs::path& p) // Verzeichnis auflisten.
{
   if( fs::is_directory(p) )          // Ein Verzeichnis?
   {
     cout << "Verzeichnis: " << fs::canonical(p) << endl;

     for( auto& entry : fs::directory_iterator(p))
        cout << "    " << entry.path().filename() << endl;

     return true;
   }
   else
     return false;
}
