// pack_demo.cpp: Operationen mit Parameterpacks
//-----------------------------------------------
#include <iostream>
#include <string>
#include <cmath>
using namespace std;

template<class ... Args> 
auto add( const Args& ...args)
{
    return (args + ...);      // Faltungsausdruck.
//    return ( ... + args);   // Auch mglich.
}

template<class T>             // Hilfsfunktion.
void print( const T& arg) { cout << "  " << arg; }

template<typename... T>
void sqrts(T... args)         // Quadratwurzeln anzeigen.
{
    const int size = sizeof...(args);
    double sqroots[size] = { sqrt(args)... }; // Initialisierungsliste
    for( int i; i < size; ++i)
       cout << "  " << sqroots[i];
    cout << endl;
 
    // Einige fold expressions:
    ( cout << ... << args);            // Argumente anzeigen.
    cout << endl;
    ( print( args), ... );             // Mit Zwischenraum.
    cout << endl;
    ( print( sqrt(args)), ... );       // Und die Wurzeln.
    cout << endl;
}

int main()
{
    cout << add(1,2,3) << endl;
    string s1 ="Sonnen", s2 ="blumen", s3 ="kerne"; 
    cout << add(s1, s2, s3) << endl;

    sqrts( 2, 3.1, 4.2, 9);
    return 0;
}
 