// optional_any_demo.cpp: Klassen optional und any verwenden.
// ---------------------------------------------------------
#include <optional>
#include <any>
#include <iostream>
#include <string>
using namespace std;

optional<string> find(int key)   // Wert zum Schlssel key suchen.
{
    static pair<int, string> arr[] = { { 111,"Tom" },{ 222,"Jerry" } };

    for (auto& el : arr)
        if (key == el.first)  return el.second;
    // return nullopt;           
    return {};                 // Keinen Wert zurckgeben, falls
}                              // Schlssel nicht gefunden wurde.

int main()
{
    optional<string> str;
    if (!str)                  // oder: if( str.has_value() == false)
        cout << "str speichert keinen Wert!\n";

    str = find(222);
    if (str)                      // oder: if( str.has_value())
        cout << "find(222) liefert: " << *str << endl;

    cout << "find(123) liefert: "
        << find(123).value_or("\"leer\"") << endl;

    any any1, any2(1.2);    // Knnen einen beliebigen Wert speichern.
                            // any1 ist leer, d.h. any1.has_value() gibt false zurck.

    any1 = any2;            // Werte haben Typ double.
    try
    {
        cout << any_cast<int>(any1) << endl;   // Fehler, da any1
    }                                          // kein int enthlt.
    catch (const bad_any_cast& ex)
    {
        cout << ex.what() << endl;
    }

    any1 = string("Hallo ");           // Neue Werte.
    any2 = "Emil";

    cout << "Objekt any1: " << any_cast<string&>(any1) << endl;   // OK
    //  Die gleiche Anweisung mit any2 wirft eine Exception:
    //  cout << "Objekt any2: " << any_cast<string&>(any2) << endl;

    if( any2.type() == typeid(string) )      // false, da any2 ein 
    {                                        // const char* enthlt. 
        string name = any_cast<string>(any2);
    }
    return 0;
}
