// ---------------------------------------------------
// interpol.cpp: Die Template-Funktion interpolSearch()
// ---------------------------------------------------
#include <iostream>
using namespace std;

template <class T>
long interpolSearch(const T& key, T* vp, int len) 
{
   int  expect, begin = 0, end = len - 1;
   double temp;

   if( end < 0                      // Vektor leer.
       || key > vp[end]             // oder key nicht im
       || key < vp[begin] )         // Bereich des Vektors
      return -1;

   while( begin <= end )
   {
      if(key > vp[end] || key < vp[begin] ) // key nicht
         return -1;                         // im Bereich.
      
      temp  = (double)(key - vp[begin])/(vp[end]-vp[begin]);
      temp  = temp * (end - begin) +0.5;

      expect = begin + (int)temp; 

      if( vp[expect] == key )    // Schlssel gefunden? 
         return expect; 
      if( vp[expect] > key)
          end = expect - 1;
      else begin = expect+1;
   }  
    
   return -1;               
}

template <class T>
void insertionSort( T* vp, int len) 
{
   T temp;

   for( int i=0; i < len; i++)
   {
       temp = vp[i];       // Element herausnehmen.
                           // Groessere Elemente hochshiften:
       int j;
       for( j = i-1; j >= 0 && vp[j] > temp; j--)
          vp[j+1] = vp[j];

       vp[j+1] = temp;            // Einfgen.
   }
}

template <class T>
void display(T* vp, int len)
{
   cout << "\n\nDer Vektor: " << endl;
   for(int i = 0; i < len; i++)
   {
      cout << vp[i] << "  ";
      if( (i+1)%10 == 0)
          cout << endl;
   }
   cout << endl; cin.get();
}

short  sv[5] = { 7, 9, 2, 4, 1};
double dv[5] = { 5.7, 3.5, 2.1, 9.4, 4.3 };

int main()
{
   cout << "\nInstantiierung fuer Typ short: " << endl;
   display(sv, 5);

   insertionSort(sv, 5);
   
   cout << "\nNach dem Sortieren: ";
   display(sv, 5);

   short key;
   cout << "\nVektorelement? "; cin >> key; cin.sync();

   int pos = interpolSearch(key, sv, 5);
   if( pos != -1)
       cout << "\nGefunden!" << endl, cin.get();
   else 
       cout << "\nNicht gefunden!" << endl, cin.get();
   
   // -------------------------------------------------

   cout << "\nInstantiierung fuer Typ double: " << endl;
   display(dv, 5);
   
   insertionSort(dv, 5);
   
   cout << "\nNach dem Sortieren: ";
   display(dv, 5);

   double dkey;
   cout << "\nVektorelement? "; cin >> dkey; cin.sync();

   pos = interpolSearch(dkey, dv, 5);
   if( pos != -1)
       cout << "\nGefunden!" << endl, cin.get();
   else 
       cout << "\nNicht gefunden!" << endl, cin.get();
   
   return 0;
}     
