// ----------------------------------------------------- 
// hotpot_t.cpp : Simulation eines Routing-Verfahrens,
//                dem Hot-Potato-Algorithmus, mit Hilfe 
//                eines Vektors von Queues.
// ----------------------------------------------------- 

#include <cstdlib>       // Fuer srand(), rand()
#include <ctime>         // Fuer time()

#include <iostream>
#include <iomanip>
using namespace std;

#include "VekQueue.h"

int main()
{
   const int nQueues = 9;
   VekQueue<int> vq(nQueues);      // Vektor mit 9 Queues
   
   cout << "\nEs wurden " << nQueues << " Queues angelegt."
        << endl;

   cout << "\nJetzt werden die Queues mit Hilfe des "
           "Hot-Potato-Algorithmus gefuellt."
        << endl;

   int i;
   for( i = 0; i < 100; ++i)      // 100 Elemente einfuegen
     vq.push(rand()%100); 

   cout << "\nEinige Elemente aus zufaellig "
           "gewaehlten Queues entfernen ... " 
        << endl;
   for( i = 0; i < 50; ++i)       // 50 Elemente loeschen
       vq.pop();

   cout << "\nDie restlichen Elemente:" << endl;
   for( i = 0; i < nQueues; ++i)  // Elemente entnehmen und anzeigen.
   {
      cout << "\n" << i+1 << ".Queue: ";
      while( vq.size(i) > 0 )
      {
         cout << setw(4) << vq.pop(i);
      }
      cout << endl;
   }

   return 0;
}
