// KontoFkt.cpp
// Eine Funktion definieren und aufrufen, die ein Liste
// der berzogenen Konten ausgibt.
// -------------------------------------------------- 

#include "konto.h"      // Definition der Klasse Konto.

Konto kontoTab[] =      // Tabelle mit Konto-Objekten.
{
  Konto("Twain, Mark", 1234567, -3434.30),
  Konto("Crusoe, Robinson", 200000, 0.00), 
  Konto("Karstadt, Liesl", 543001, +777.70),
  Konto("Valentin, Karl", 543002, -1111.10),
};

int anz = sizeof(kontoTab) / sizeof(Konto);

// Prototyp:
int displayOverdraws( const Konto *kTab, int anz,
                      double limit);
int main()
{
   double limit = 0.0;
    
   cout << "Ausgabe der berzogenen Konten!\n" 
        << "Das sind die Konten, die ein bestimmtes Limit\n"
        << "z.B. -1000.00 unterschreiten.\n" << endl;

   cout << "Was ist das Limit? ";
   cin >> limit;

   cout << "  Liste der berzogenen Konten:\n" << endl;

   if( displayOverdraws( kontoTab, anz, limit) == 0)
     cout << "\nKein berzogenes Konto gefunden!" << endl;

   return 0;
}

int displayOverdraws( const Konto *kTab, int anz, double limit)
{
   int count = 0;
   const Konto* kPtr;
   
   for( kPtr = kTab; kPtr < kTab + anz; ++kPtr)
      if( kPtr->getStand() < limit ) // unterm Limit?
      {
         kPtr->display();            // Ja -> Anzeigen. 
         ++count;
      }
   return count;
}