// uniquePtr2.cpp
// unique_ptr als Argument/Return-Wert von Funktionen
// --------------------------------------------------
#include <iostream>
#include <memory>
using namespace std;

void test( unique_ptr<int> p)
{   cout << "In test():  *p = " << *p << endl;  }

void square(unique_ptr<int>& p)  { if(p) *p *= *p; }

void print( unique_ptr<int> *a, int len)
{   for( int i = 0; i < len; ++i)
       if(a[i]) { cout.width(6); cout << *a[i]; }
    cout << endl;
}
unique_ptr<int> create()
{   static int a(0);
    return unique_ptr<int> (new int(a++)); 
}

int main()
{
   unique_ptr<int> up(new int(5)); 
   unique_ptr<int> up_arr[10];     // Vektor mit Smart Pointern. 

   square( up);           // Ok, "call by reference".
   cout << "Quadrat: " << *up << endl;

//  test(up);             // Fehler! Kein Kopierkonstruktor.
   test( move(up));       // OK! Move-Konstruktor. Vorsicht! 
//  *up = 7;              // Fehler: up ist jetzt Null.

   up = create();         // Move-Zuweisung!
   up_arr[0] = move(up);  // Ebenso.
   
   for( int i = 0; i < 10; ++i)
	   up_arr[i] = create();    // Zerstrt altes Objekt *up_arr[0] 
   print(up_arr, 10);           // Vektor anzeigen.

   for( int i = 0; i < 10; i+=2)        // Objekte mit geradem Index
	   up_arr[i].reset();               // lschen.
   print(up_arr, 10);                   // Vektor anzeigen.

   for( int i = 0; i < 10; ++i)         // Alle Objekte lschen.
	   up_arr[i].reset();               // reset() mit Null ok. 

   return 0;
}
