// -------------------------------------------------------- 
//  ball2.cpp
//  Simuliert einen springenden Ball
//  Kommandos: Taste [Esc] = Beenden,
//             Taste [+] = Schneller, Taste [-] = Langsamer
//  -------------------------------------------------------
//  Damit die Steuerzeichen wirksam sind, mu ein
//  entsprechender Bildschirmtreiber geladen sein.
//  Dies ist auf allen gngigen Linux/UNIX-Systemen gegeben.
//  Unter Windows gilt das auch fr Programme, die in einer
//  Cygwin-Umgebung ablaufen.
// -------------------------------------------------------- 

#include <iostream>
#include <string>
using namespace std;

#include "conio_unix.h"    // Fr _kbhit() und _getch()
#include "myMakros.h"
#define  ESC   27          // ESC beendet das Programm

unsigned long long delay = 10000000LL;    // Verzgerung

int main()
{
   int x = 2, y = 2, dx = 1, geschw = 0;
   bool ende = false;
   string boden(80, '-'),
          header   = "****  SPRINGENDER BALL  ****",
          commands = "[Esc] = Beenden     "
                     "[+] = Schneller     [-] = Langsamer";

   FARBE(WEISS,BLAU);
   CLS;
   LOCATE(1,25);  cout << header;
   LOCATE(24,1);  cout << boden;
   LOCATE(25,10); cout << commands;

   LOCATE(y,x);  cout << 'o';         // Ball anzeigen

   while( !ende)            // solange das Ende-Flag
   {                        // nicht gesetzt ist.
     long long warten; 
     for( warten = 0; warten < delay; ++warten)
       ;

     if(x == 1 || x == 79) dx = -dx;    // An einer Wand?
     if( y == 23 )                      // Am Boden?
     {
       geschw = - geschw;
       if( geschw == 0 ) geschw = -7;   // Neu anstossen
     }
     geschw += 1;                  // Beschleunigung = 1

     LOCATE(y,x); cout <<  ' ';    // Anzeige lschen
     y += geschw;  x += dx;        // Neue Position
     LOCATE(y,x); cout << 'o';     // Ball auf neuer Position

     if( _kbhit() != 0 )           // Taste gedrckt?
     {
        switch(_getch())                // ja 
        {
          case '+':  delay -= delay/5;  // schneller   
                     break;
          case '-':  delay += delay/5;  // langsamer
                     break;
          case ESC:  ende = true;       // Pgm. beenden
        }
     }
   }
   NORMAL;
   CLS;
   return 0;
}
