// conio_unix.c

#include <stdio.h>
#include <termios.h>

// --- _getch() ---

int _getch()
{
   int ch = -1,
   fd = 0;           // fileno(stdin)
   struct termios neu, alt;

   tcgetattr(fd, &alt);
   neu = alt;

   neu.c_lflag &= ~(ICANON|ECHO);  // Keine Zeilenpufferung, kein Echo
   tcsetattr(fd, TCSANOW, &neu);

   ch = getchar();

   tcsetattr(fd, TCSANOW, &alt);

   return ch;
}

// --- _kbhit() ---

int _kbhit()
{
   int ch = -1, fd = 0;
   struct termios neu, alt;

   tcgetattr(fd, &alt);
   neu = alt;

   neu.c_lflag &= ~(ICANON|ECHO);  // Keine Zeilenpufferung, kein Echo
   neu.c_cc[VMIN] = 0;             // Mindestens 0 Zeichen.
   neu.c_cc[VTIME] = 1;            
   tcsetattr(fd, TCSANOW, &neu);

   ch = getchar();

   tcsetattr(fd, TCSANOW, &alt);
   if( ch != -1)
      ungetc(ch, stdin);

   return ((ch != -1) ? 1 : 0);
}
/*
#include <iostream>
using namespace std;

int main()
{
   int c;
   while( !_kbhit())
     cout << "Eine Taste druecken!\033[2K";

   c = _getch();
   cout << "Zeichen " << (char)c << " : " << c << '\n'; 

   return 0;
}
*/
