// ------------------------------------------------------ 
// myMakros.h 
// Header-Datei mit den Makros 
// ABS, MIN, MAX, CLS, LOCATE, FARBE, NORMAL, INVERS
// und symbolische Konstane fr Farben.
// ------------------------------------------------------- 

#ifndef _MYMAKROS_
#define _MYMAKROS_

#include <iostream>
using namespace std;

// -------------------------------------------------------------
// Makro ABS
// Aufruf:  ABS( wert) 
// Liefert den Absolutwert von wert
 
#define ABS(a) ( (a) >= 0 ? (a) : -(a))

// -------------------------------------------------------------
// Makro MIN
// Aufruf:  MIN(x,y) 
// Liefert das Minimum von x und y

#define MIN(a,b) ( (a) <= (b) ? (a) : (b))

// -------------------------------------------------------------
// Makro MAX
// Aufruf:  MAX(x,y) 
// Liefert das Maximum von x und y

#define MAX(a,b) ( (a) >= (b) ? (a) : (b))


//--------------------------------------------------------------
// Makros zur Steurung des Bildschirms
// -------------------------------------------------------------
// Makro CLS
// Aufruf:  CLS; 
// Lscht den Bildschirm 

#define CLS   (cout << "\033[2J")  // Bildschirm lschen

// -------------------------------------------------------------
// Makro LOCATE
// Aufruf:  LOCATE(zeile, spalte); 
// Setzt den Cursor auf die angegebene Position (zeile,spalte).
// (1,1) ist linke obere Ecke.

#define LOCATE(z,s) (cout <<"\033["<< (z) <<';'<< (s) <<'H')

// -------------------------------------------------------------
// Makro FARBE
// Aufruf:  FARBE(vordergrund, hintergrund); 
// Setzt die Vordergrund- und Hintergrundfarbe fr nachfolgende 
// Ausgabe.

#define FARBE( v, h) (cout << "\033[1;3"<< (v) \
                           <<";4"<< (h) <<'m' << flush)
//  1: Vordegrund hell
// 3x: Vordergrundfarbe x
// 4x: Hintergrundfarbe x

// Farbwerte fr das Makro FARBE
// Beispielaufruf: FARBE( WEISS,BLAU);

#define SCHWARZ  0
#define ROT      1
#define GRUEN    2
#define GELB     3
#define BLAU     4
#define MAGENTA  5
#define CYAN     6
#define WEISS    7

// -------------------------------------------------------------
// Makro NORMAL
// Aufruf:  NORMAL; 
// Setzt die Bildschirmattribute auf die Standardwerte zurck.

#define NORMAL  (cout << "\033[0m")

// -------------------------------------------------------------
// Makro INVERS
// Aufruf:  INVERS; 
// Die nachfolgende Ausgabe wird invers dargestellt.

#define INVERS  (cout << "\033[7m")

#endif   //  _MYMAKROS_
