//-------------------------------------------------------------
//  Ellipse.cpp
//  Dieses Programm zeichnet eine Ellipse.
//  Fr die Punkte (x,y) einer Ellipse mit dem Mittelpunkt (0,0),
//  der Hauptachse A und der Nebenachse B gilt: 
//    x = A*cos(t), y = B*sint(t)  fr  0 <= t <= 2*PI .
//  --------------------------------------------------
//  Damit die Steuerzeichen wirksam sind, mu ein
//  entsprechender Bildschirmtreiber geladen sein.
//  Dies ist auf allen gngigen Linux/UNIX-Systemen gegeben.
//  Unter Windows gilt das auch fr Programme, die in einer
//  Cygwin-Umgebung ablaufen.
//  Eine Lsung fr Windows finden Sie im Verzeichnis 
//  Source_mit_Visual_C++_20xx-Projekten\kap08.
//-------------------------------------------------------------

#include <iostream>
#include <cmath>       // Prototypen von sin() und cos()
using namespace std;

#define  CLS         (cout << "\033[2J") 
#define  LOCATE(z,s) (cout <<"\033["<< (z) <<';'<< (s) <<'H')
#define  DOT(x,y)    (LOCATE(y,x) << '*')

#define  PI 3.1416
#define  Mx 40               // Der Punkt (Mx, My) ist der
#define  My 12               // Mittelpunkt der Ellipse.
#define  A  25               // Lnge der Hauptachse, 
#define  B  10               // Lnge der Nebenachse. 

int main()
{
    int x,y;                 // Bildschirmkoordinaten.  

    CLS;
                   // 0 <= t <= PI/2 ist ein 1/4-Kreis:
    for( double t = 0.0 ; t <= PI/2 ; t += 0.03)
    {
       x = (int) (A * cos(t) + 0.5);
       y = (int) (B * sin(t) + 0.5);

       DOT( x+Mx, y+My);
       DOT( x+Mx,-y+My);
       DOT(-x+Mx, y+My);
       DOT(-x+Mx,-y+My);
    }
    LOCATE(24,1);

    return 0;
}
