// ----------------------------------------------------
// fakult.cpp 
// Berechnet die Fakultt einer ganzen Zahl sowohl
// iterativ, d.h. mit Hilfe einer Schleife, als auch 
// rekursiv.
// ----------------------------------------------------
#include <iostream>
#include <iomanip>
using namespace std;

#define N_MAX   20

long double fakult1(unsigned int n);
long double fakult2(unsigned int n);

int main()
{
   unsigned int n;

   cout << fixed << setprecision(0);  // ohne Stellen nach
                                      // dem Punkt ausgeben

   //  ---  Iterative Berechnung der Fakultt  --- 

   cout << setw(10) << "n"  <<  setw(30) << "Fakultaet von n"
        << "           (Iterative Berechnung)\n" 
        << "    -----------------------------------------"
        << endl;

   for( n = 0; n <= N_MAX;  ++n)
      cout << setw(10) << n << setw(30) << fakult1(n) << endl;

   cout << "\nWeiter mit <Return>";
   cin.get();

   //  ---  Rekursive Berechnung der Fakultt  ---- 

   cout << setw(10) << "n"  <<  setw(30) << "Fakultaet von n"
        << "           (Rekursive Berechnung)\n" 
        << "    -----------------------------------------"
        << endl;

   for( n = 0; n <= N_MAX;  ++n)
      cout << setw(10) << n << setw(30) << fakult2(n) << endl;
   
   cout << endl;

   return 0;
}

long double fakult1(unsigned int n)   // Iterative Berechnung
{
   long double ergebnis = 1.0;
   for( unsigned int i = 2; i <= n; ++i)
       ergebnis *= i;

   return ergebnis;
}

long double fakult2(unsigned int n)   // Rekursive Berechnung
{
   if( n <= 1)
      return 1.0;
   else
      return fakult2(n-1) * n;
}
