// ----------------------------------------------------
// power.cpp 
// Definition und Aufruf einer eigenen Funktion pow() zur 
// Berechnung ganzzahliger Potenzen einer Gleitpunktzahl.
// berladung der Standard-Funktion pow()
// ----------------------------------------------------
#include <iostream>
#include <cmath>
using namespace std;

double pow(double basis, int exp);

int main()             // eigene Funktion pow() testen
{
   double basis    = 0.0;
   int    exponent = 0;

   cout << "  **** Berechnet ganzzahlige Potenzen ****\n"
        << endl;

   cout << "Testwerte eingeben.\n"
        << "Basis (Gleitpunktzahl): ";  cin >> basis;
   cout << "Exponent (ganze Zahl):     ";  cin >> exponent;

   cout << "Ergebnis von " << basis << " hoch " << exponent 
        << " = " << pow( basis, exponent) << endl;

   cout << "Berechnung mit der Standard-Funktion: " 
        << pow( basis, (double)exponent) << endl;

   cout << endl;

   return 0;
}

double pow(double basis, int exp)
{
    if( exp == 0)     return 1.0;

    if( basis == 0.0)
        if( exp > 0)  return 0.0;
        else          return HUGE_VAL;

    if( exp < 0) 
    {
       basis = 1.0 / basis;
       exp = -exp;
    }

    double power = 1.0;
    for( int n = 1; n <= exp; ++n)
        power *= basis;

    return power;
}
