// -----------------------------------------------------
//  Password.cpp
//  Es werden die Funktionen getPassword() und
//  changePassword() getestet.
//
//  Nach richtiger Eingabe des Passwortes ( hchstens 
//  drei Versuche innerhalb von 60 Sekunden) kann das 
//  Passwort gender werden.
//  --------------------------------------------------
//  Damit die Steuerzeichen wirksam sind, mu ein
//  entsprechender Bildschirmtreiber geladen sein.
//  Dies ist auf allen gngigen Linux/UNIX-Systemen gegeben.
//  Unter Windows gilt das auch fr Programme, die in einer
//  Cygwin-Umgebung ablaufen.
// -----------------------------------------------------

#include <iostream>
#include <iomanip>
#include <string>
#include <cctype>
using namespace std;

bool getPassword(void);             // Passwort einlesen .
bool changePassword(void);          // Passwort ndern.

inline void cls()
{
   cout << "\033[2J\n";   // Falls die ANSI-Steuerzeichen nicht
}                         // vefgbar sind: nur New-Lines ausgeben.

inline void weiter()
{
   cout << "\n\nWeiter mit der Return-Taste! ";
   cin.sync();  cin.clear();        // Nur neue Eingabe
   while( cin.get() != '\n')
       ;
}

inline char getYesOrNo()      // Zeichen J oder N einlesen  
{
   char c = 0;
   cin.sync();  cin.clear();  // Nur neue Eingabe
   do
   {
     cin.get(c);
     c = toupper(c);    // Auch Kleinbuchstaben zulassen.
   }
   while( c != 'J'  && c != 'N');
   return c; 
}

static string header =
"\n\n      ****  Passwort-Handling testen  ****\n\n";

static string menu =
"\n\n              B = Buchung durchfuehren"
"\n\n              E = Ende des Programms"
"\n\n Ihre Wahl:   ";

int main()
{
   char wahl = 0;

   while( wahl != 'E')
   {
     cls();
     cout << header << menu;

     cin.get(wahl);   wahl = toupper(wahl);

     cls();
     cout << header << endl;

     switch( wahl)
     {
       case 'B':
         if( !getPassword() )
         {
            cout << "Keine Berechtigung!" << endl;
            weiter();
         }
         else
         {
            cout << "Herzlich willkommen!\n\n"
                 << "Wollen Sie das Passwort aendern? (j/n)";
            if( getYesOrNo() == 'J')
            {
              if( changePassword() )
                cout << "Passwort geaendert!" << endl;
              else 
                cout << "Passwort unveraendert!" << endl;
              weiter();
            }

            // Hier folgen die Anweisungen fr die Buchung

         }
         break;

       case 'E':
         cls();  cout << "\n    Bye Bye!" << endl;
     }
   } // Ende while

   return 0;
}

