// ----------------------------------------------------
// kreis.cpp
// Definition und Aufruf der Funktion kreis().
// ----------------------------------------------------

#include <iostream>
#include <iomanip>
#include <string>
using namespace std;

// Prototyp von kreis()
void kreis( const double& rad, double& um, double& fl);
 
const double startRadius =  0.5,     // Start, Ende und
             endRadius   = 10.0,     // Schrittweite der
             step        =  0.5;     // Tabelle

string header = "\n        ***** KREISBERECHNUNG ***** \n",
       line( 50, '-');

int main()
{
    double rad, umfang, flaeche;

    cout << header << endl;

    cout << setw(10) << "Radius" 
         << setw(20) << "Umfang"
         << setw(20) << "Flche\n" << line << endl;

    cout << fixed;                 // Festpunktdarstelung
    for( rad = startRadius;
         rad < endRadius + step/2;  rad += step)
    {
       kreis( rad, umfang, flaeche);
       cout << setprecision(1) << setw(8) << rad 
            << setprecision(5) << setw(22) << umfang
                               << setw(20) << flaeche << endl;
    }

    return 0;
}

// Kreis-Umfang und Flche berechnen
void kreis( const double& r, double& u, double& f)
{
   const double pi = 3.1415926536;
   u = 2 * pi * r;
   f = pi * r * r;
}