// ---------------------------------------------------
// artikel.cpp 
// Definition der Artikel-Methoden, die nicht
// inline definiert sind.
// Konstruktor und Destruktor zeigen Aufrufe an.
// ---------------------------------------------------

#include "artikel.h"            // Definition der Klasse

#include <iostream>
#include <iomanip>
using namespace std;

// Definition des statischen Datenelementes:
int Artikel::anzObjekte = 0;    // Anzahl Objekte

// Definition der Konstruktoren und des Destruktors:

Artikel::Artikel( long nr, const string& name, double vk)
{
   setNr(nr);   setName(name);   setVK(vk);
   ++anzObjekte;
   cout << "Es wird ein Objekt fuer den Artikel " << name
        << " angelegt.\n"
        << "Das ist der " << anzObjekte << "-te Artikel!"
        << endl;
}

Artikel::Artikel( const Artikel& art)
:nr(art.nr), name(art.name), vk(art.vk)
{
   ++anzObjekte;
   cout << "Es wird ein Kopie des Artikels " << name
        << " angelegt.\n"
        << "Das ist der " << anzObjekte << "-te Artikel!"
        << endl;
}

Artikel::~Artikel()
{
   cout << "Das Objekt fuer den Artikel " << name
        << " wird zerstoert.\n"
        << "Es gibt noch " << --anzObjekte << " Artikel!"
        << endl;
}

// Die Methode print() zeigt ein Artikel am Bildschirm an.
void Artikel::print()
{
   ios::fmtflags savedFlags = cout.flags();    // Flags von cout merken 
   cout << fixed << setprecision(2) 
        << "-----------------------------------------\n"
        << "Artikel-Daten:\n"
        << "  Nummer ......:  " << nr    << '\n'
        << "  Name   ......:  " << name  << '\n'
        << "  Verkaufspreis:  " << vk    << '\n'
        << "-----------------------------------------" << endl;
   cout.flags(savedFlags);      // Alte Flags wieder herstellen

   cout << "  --- Weiter mit der Return-Taste --- ";
   cin.get();
}
