// fs_demo.cpp : Zeigt den Pfad eines Verzeichnisses oder
//               die Gre einer regulren Datei an.
// -------------------------------------------------------

#include <iostream>
#include <filesystem>

using namespace std;
using namespace std::filesystem; 

int main(int argc, char* argv[])
{
   switch( argc)
   {
     case 1:               // Kein Argument aus der Kommandozeile.
       cout << "Das Aktuelle Verzeichnis:\n"
            << current_path() << endl;
       break;
     case 2:               // Ein Argument aus der Kommandozeile.
     {
       path p(argv[1]);
       if( is_directory(p))                // Ist p ein Verzeichnis?
          cout << p << " ist ein Verzeichnis. Absoluter Pfad:\n"
               << canonical(p) << endl;
       else if( is_regular_file(p))        // Oder eine regulre Datei?
          cout << p << " hat die Groesse " << file_size(p) << endl;
       else
          cout << p << " existiert nicht oder ist keine regulre Datei"
                       " bzw. kein Verzeichnis." << endl;
       break;
     }
     default: cout << "Verwendung: fs_demo [Pfad]" << endl;
   }
   return 0;
}
