// ---------------------------------------------------------------
// swapbits.cpp:  Die Funktion swapbits() vertauscht in einem    
//                int-Wert zwei Bits.                            
//                Argumente: Der int-Wert und zwei Bit-Nummern.  
//                Return-Wert: Der neue int-Wert.                
// ---------------------------------------------------------------

int swapbits( int x, int bitnr1, int bitnr2)   // In x zwei Bits 
{                                              // tauschen       
    int newx, mask1, mask2;
    int msb = 8 * sizeof(int) - 1;         // Hoechste Bit-Nummer 

    if( bitnr1 < 0 || bitnr1 > msb || bitnr2 < 0 || bitnr2 > msb)
       return x;              // Zurueck, falls ungueltige Bit-Nr. 

    mask1 = (1 << bitnr1);           // 1 in die Position bitnr1 
    mask2 = (1 << bitnr2);           // 1 in die Position bitnr2 

    newx = x & ~(mask1 | mask2);           // Beide Bits loeschen 

    if( x & mask1 )  newx |= mask2;        // Bits tauschen      
    if( x & mask2 )  newx |= mask1;

    return( newx);
}
