// -------------------------------------------------------
// WebAccount_t.cpp
// Testet die Klassen WebAccount und UserTable
// zur passwortgeschtzten Benutzerverwaltung. 
// -------------------------------------------------------

#include "WebAccount.h"

int menu()
{
    int choice;

    cin.clear(); cin.sync();
    cout <<   " 1 = Neues Webaccount anlegen "
         << "\n 2 = Einloggen "
         << "\n 3 = Ausloggen "
         << "\n 4 = Webaccount entfernen"
         << "\n 5 = Aktive User anzeigen"
         << "\n 0 = Programm beenden " << endl;
    cin >> choice;

    return choice;
}

void userInput( string& pw, string& name)
{
   cout << "Bitte geben Sie Ihren Benutzernamen an: " << endl;
   cin >> name;

   cout << "Bitte geben Sie Ihr Passwort ein: " << endl;
   cin >> pw;
}

int main()
{
   string passw, uname;
   UserTable ht;
   int choice;

   while( (choice = menu())  != 0 )
   {
      switch( choice )
      {
         case 1:                         // Neues Account anlegen
            userInput(passw, uname);

            if(ht.addUser(passw, uname))
                cout << "\nNeues Konto wurde angelegt. " << endl;
            else
                cout << "\nKonto existiert bereits." << endl;
            break;

         case 2:                             // Einloggen
            userInput(passw, uname);
            if( ht.login(passw, uname))
               cout << "\nHerzlich willkommen " << uname 
                    << "!" << endl;
            else
               cout << "\nLogin fehlgeschlagen. " << endl; 
            break;

         case 3:                             // Ausloggen
            userInput(passw, uname);
            if( ht.logout(passw, uname))
               cout << "\nLogout erfolgreich. Auf Wiedersehen!" << endl;
            else
               cout << "\nWebaccount existiert nicht. " << endl; 
            break;

         case 4:                             // Webaccount entfernen
            userInput(passw, uname);
            if( ht.removeUser(passw, uname))
               cout << "\nWebaccount wurde entfernt." << endl;
            else
               cout << "\nWebaccount existiert nicht. " << endl; 
            break;
 
         case 5:
            cout << "\nAlle aktiven User: " << endl;
            ht.displayActiveUsers();
            break;
      }
      cout << "\nWeiter mit Return.\n\n";
      cin.clear(); cin.sync();
      cin.get();
   }
   return 0;
}
