// thread_initialize.cpp
// Initialisiert einen Thread mit einem Funktionsobjekt.
// ---------------------------------------------------------
#include <thread>
#include <iostream>
using namespace std;

struct FuncObj
{
    FuncObj()                      // Default-Konstruktor
    { cout << "\nKonstruktor erzeugt Objekt: "
           << (void*)this << endl;}

    FuncObj(const FuncObj& mt)     // Kopier-Konstruktor
    { cout <<"\nKopierkonstruktor erzeugt Objekt: "
           << (void*) this << endl;}

    FuncObj(FuncObj&& mt)          // Move-Konstruktor
    { cout << "\nMove-Konstruktor erzeugt Objekt: "
           << (void*) this << endl;}

    ~FuncObj()
    { cout << "\nDestruktor zerstoert Objekt: "
           << (void*) this << endl; }

    void operator()()
    {
     cout << "\n()-Operator aufgerufen fuer Objekt: "
          << (void*) this << ". \n()-Operator beendet. "
          << endl;
    }
};

int main()
{
    FuncObj a;
    thread t(a);
    t.join();

    return 0;
}
